module Strife
  class Client
    module Summoner
      VERSION = "v1.2"

      def summoner_masteries(options = {})
        get "v1.2/summoner/#{options.delete(:summoner_id)}/masteries", options
      end

      def summoner_runes(options = {})
        get "v1.2/summoner/#{options.delete(:summoner_id)}/runes", options
      end

      def summoner_by_name(options = {})
        get "v1.2/summoner/by-name/#{options.delete(:name)}", options
      end

      def summoner_by_id(options = {})
        get "v1.2/summoner/#{options.delete(:summoner_id)}", options
      end

      def summoner_names(options = {})
        summoner_ids = options.delete(:summoner_ids).join(',')

        raise ArgumentError.new("You can not query more than 40 summoner names at one time") if summoner_ids.length > 40

        get "v1.2/summoner/#{summoner_ids}/name", options
      end
    end
  end
end
