module Strife
  class Error < StandardError
    def self.from_response(response)
      status = response[:status].to_i

      if klass = case status
                 when 400 then BadRequest
                 when 401 then NotAuthorizedError
                 when 500 then InternalServerError
                 end
        klass.new(response)
      end
    end

    class ClientError < Error; end
    class NotAuthorizedError < ClientError; end
    class BadRequest < ClientError; end

    class ServerError < Error; end
    class InternalServerError < ServerError; end
  end
end
